using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Salas_Impresoras_Datos
    {
        #region Obtener
        public long Obtener_PorDefecto_IdImpresora_Por_IdSala(long _lng_idSala)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            long lng_idPorDefecto = -1;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                             nameof(HPV_Salas_Impresoras) + "." + nameof(HPV_Salas_Impresoras.idImpresora) +
                        " FROM " + nameof(HPV_Salas_Impresoras) +
                        " WHERE  " + nameof(HPV_Salas_Impresoras) + "." + nameof(HPV_Salas_Impresoras.idSala) + "=@idSala AND " +
                                     nameof(HPV_Salas_Impresoras) + "." + nameof(HPV_Salas_Impresoras.porDefecto) + "=convert(bit,1) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idSala",  _lng_idSala)
                };

                //Rellenar el Modelo
                lng_idPorDefecto = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Salas_Impresoras_Datos) + "/" + nameof(Obtener_PorDefecto_IdImpresora_Por_IdSala), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lng_idPorDefecto;
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(long _lng_idSala, Dictionary<long, bool> _dct_Impresoras)
        {
            Exferia_Entities dbcontext = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            string str_PorDefecto = "0";//Es un string para identificar el booleano siendo "o"=False y "1"=True
            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.ProxyCreationEnabled = true;

                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(HPV_Salas_Impresoras) + " WHERE " + nameof(HPV_Salas_Impresoras.idSala) + "=" + _lng_idSala;
                dbcontext.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (_dct_Impresoras != null & _dct_Impresoras.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (KeyValuePair<long, bool> kvp_Impresora in _dct_Impresoras)
                    {
                        str_PorDefecto = "0";

                        if (kvp_Impresora.Value)
                        {
                            str_PorDefecto = "1";
                        }

                        str_SQL_Insertar += " INSERT INTO " + nameof(HPV_Salas_Impresoras) + "(" + nameof(HPV_Salas_Impresoras.idSala) + "," + nameof(HPV_Salas_Impresoras.idImpresora) + "," + nameof(HPV_Salas_Impresoras.porDefecto) + "," + nameof(HPV_Salas_Impresoras.observaciones) + ") values (" + _lng_idSala + "," + kvp_Impresora.Key + "," + str_PorDefecto + ",'')";
                    }

                    dbcontext.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................

            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Salas_Impresoras_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
